{ Diverse Änderungen von Siro am 13.04.2020 }
{ Invalidate für die Persistenten Blöcke eingeführt }
{ sie haben alle einen fOwner bekommen, also einen Besitzer }
{ Tastensteuerung eingeführt }
unit SliderComponent;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,LCLIntf,
  LCLType, LMessages;


type
  TKnob = (ksCircle,ksRectangle,ksRoundrect,ksArrowUp,ksArrowDown,ksArrowLeft,KsArrowRight);
type
  TLook = (klNormal,klRipped);
type
  TOrientation = (scHorizontal,scVertical);
type
  TMultiKnob = class(TPersistent)
   private
    FOwner       : TCustomControl;             // Siro, hier wird der Besitzer gespeichert
    FShowKnob2   : boolean; //2. Knopf sichtbar
    FShowKnob3   : boolean; //3. Knopf sichtbar
    FColorKnob2  : TColor;  //2. Farbe
    FColorKnob3  : TColor;  //3. Farbe
    FPosKnob2    : integer; //Position Knopf 2
    FPosKnob3    : integer; //Position Knopf 3
   protected
    procedure SetShowKnob2(const Value:boolean);
    procedure SetShowKnob3(const Value:boolean);
    procedure SetColorKnob2(const aColor:TColor);
    procedure SetColorKnob3(const aColor:TColor);
    procedure SetPosKnob2(const aValue:integer);
    procedure SetPosKnob3(const aValue:integer);
   public
     constructor create(aOwner:TCustomControl);// Siro neuer Constructor mit Parameter des Besitzers
   published
    property ShowKnob2   : boolean read FShowKnob2   write SetShowKnob2  default false;
    property ShowKnob3   : boolean read FShowKnob3   write SetShowKnob3  default false;
    property ColorKnob2  : TColor  read FColorKnob2  write SetColorKnob2 default cllime;
    property ColorKnob3  : TColor  read FColorKnob3  write SetColorKnob3 default clblue;
    property PosKnob2    : integer read FPosKnob2    write SetPosKnob2   default 5;
    property PosKnob3    : integer read FPosKnob3    write SetPosKnob3   default 10;
  end;

type
  TChangeEvent = procedure(const Count: integer) of object;


type
  TIndicator = class(TPersistent)
   private
    FOwner              : TCustomControl;  // Siro, hier wird der Besitzer gespeichert
    FIndicatorVisible   : boolean;      //Wert Anzeige sichtbar
    FIndicatorColor     : TColor;       //Hintergrund Wertanzeige
    FIndicatorFontColor : TColor;       //Schriftfarbe
   protected
    procedure SetIndicatorVisible(const Value:boolean);
    procedure SetIndicatorColor(const aColor:TColor);
    procedure SetIndicatorFontColor(const aColor:TColor);
   public
     constructor create(aOwner:TCustomControl);    // Siro neuer Constructor mit Parameter des Besitzers
   published
    property IndicatorVisible   : boolean read FIndicatorVisible   write SetIndicatorVisible default false;
    property IndicatorColor     : TColor  read FIndicatorColor     write SetIndicatorColor default clMoneyGreen;
    property IndicatorFontColor : TColor  read FIndicatorFontColor write SetIndicatorFontColor default clblack;

  end;
type
  TMark = class(TPersistent)
   private
        FOwner  : TCustomControl;  // Siro, hier wird der Besitzer gespeichert
    FMarkVisible        : boolean;    //Marke bei 0 oder sonstwo
    FMark2Visible       : boolean;
    FMarkColor          : TColor;
    FMarkPosition       : integer;
    FMark2Position      : integer;
    procedure SetMarkVisible(const Value:boolean);
    procedure SetMarkColor(const aColor:TColor);
    procedure SetMarkPosition(const aValue:integer);
    procedure SetMark2Visible(const Value:boolean);
    procedure SetMark2Position(const aValue:integer);
   public
    constructor create(aOwner:TCustomControl);  // Siro neuer Constructor mit Parameter des Besitzers
   published
    property MarkVisible        : boolean read FMarkVisible             write SetMarkVisible default false;
    property MarkColor          : TColor  read FMarkColor               write SetMarkColor default clNavy;
    property MarkPosition       : integer read FMarkPosition            write SetMarkPosition default 0;
    property Mark2Visible       : boolean read FMark2Visible            write SetMark2Visible default false;
    property Mark2Position      : integer read FMark2Position           write SetMark2Position;
  end;
type
  TScale = class(TPersistent)
   private
    FOwner           : TCustomControl;  // Siro, hier wird der Besitzer gespeichert
    FLineColor       : TColor;
    FMarkColor       : TColor;
    FInterval        : integer;
    FShowScale       : boolean;
    FOtherSide       : boolean;
    FBigMarkColor    : TColor;
    FBigMarkInterval : integer;
    FShowBigMark     : boolean;
    FBigMarkSize     : double;
    procedure SetLineColor(const aColor:TColor);
    procedure SetMarkColor(const aColor:TColor);
    procedure SetInterval(const aValue:integer);
    procedure SetShowScale(const Value:boolean);
    procedure SetOtherSide(const Value:boolean);
    procedure SetBigMarkColor(const aColor:TColor);
    procedure SetBigMarkInterval(const aValue:integer);
    procedure SetShowBigMark(const Value:boolean);
    procedure SetBigMarkSize(const aValue:double);
   public
    constructor create(aOwner:TCustomControl);  // Siro neuer Constructor mit Parameter des Besitzers
    property BigMarkSize  : double Read FBigMarkSize  Write SetBigMarkSize;
   published
    property LineColor : TColor  Read FLineColor Write SetLineColor default clblack;
    property MarkColor : TColor  Read FMarkColor Write SetMarkColor default clnavy;
    property Interval  : integer Read FInterval  Write SetInterval default 2;
    property ShowScale : boolean Read FShowScale Write SetShowScale default false;
    property OtherSide : boolean Read FOtherSide Write SetOtherSide default false;
    property BigMarkColor     : TColor  Read FBigMarkColor     Write SetBigMarkColor default clnavy;
    property BigMarkInterval  : integer Read FBigMarkInterval  Write SetBigMarkInterval default 5;
    property ShowBigMark      : boolean Read FShowBigMark      Write SetShowBigMark default false;
  end;
type
  TTrack = class(TPersistent)
   private
    FOwner     : TCustomControl;
    FSlotColor           : TColor;       //Schlitzfarbe
    FSlotColorSel        : TColor;       //Schlitzfarbe selektiert
    FSlotColorSelVisible : boolean;      // Selektiertefarbe ein
    FSlotColorExt        : TColor;       //Schlitzfarbe extra
    FSlotColorExtVisible : boolean;      // Extrafarbe ein
    FExtMin              : integer;      //Min Wert
    FExtMax              : integer;      //Max Wert
    procedure SetSlotColor(const aColor:TColor);
    procedure SetSlotColorSelVisible(const Value:boolean);
    procedure SetSlotColorSel(const aColor:TColor);
    procedure SetSlotColorExtVisible(const Value:boolean);
    procedure SetSlotColorExt(const aColor:TColor);
    procedure SetExtMin(const aValue:integer);
    procedure SetExtMax(const aValue:integer);
   public
    constructor create(aOwner:TCustomControl);
   published
   property TrackColor         : TColor  read FSlotColor                     write SetSlotColor default clWhite;
   property SelColor           : TColor  read FSlotColorSel                  write SetSlotColorSel default clGray;
   property ShowSelRange       : boolean read FSlotColorSelVisible           write SetSlotColorSelVisible default true;
   property ExtraColor         : TColor  read FSlotColorExt                  write SetSlotColorExt default clred;
   property ShowExtraColor     : boolean read FSlotColorExtVisible           write SetSlotColorExtVisible default false;
   property ExtraRangeMin      : integer read FExtMin                        write SetExtMin default 0;
   property ExtraRangeMax      : integer read FExtMax                        write SetExtMax default 0;

end;
type
 TSliderComponent = class (TCustomControl)  //  frueher (TGraphicControl)  Siro 13.04.2020
  private
    { Private declarations }
    FKnob                : TKnob;        //SchieberKnopf
    FLook                : TLook;        //Knopf Aussehen
    FLookColor           : TColor;       //Stiftfarbe vom Knopf für Look
    FBackgroundColor     : TColor;       //Hintergrundfarbe
    FKnobColor           : TColor;       //SchiebeKnopffarbe
    FBorderColor         : TColor;       //Randfarbe
    FBorderWidth         : integer;      //Randdicke
    FMin                 : integer;      //kleinster Wert
    FMax                 : integer;      //größter Wert
    FStep                : integer;      //Schritt bei Klick
    FPosition            : integer;      //Startwert und Position
    FIndicator           : TIndicator;   //Wertanzeige
    FMark                : TMark;        //Markierung
    FOnChange            : TChangeEvent; //Geändert Ereigniss
    FScale               : TScale;       //Skala
    FMultiKnob           : TMultiKnob;   //Mehrere Knöpfe
    FFocusColor1         : TColor;       //1.Farbe des Focusrahmens
    FFocusColor2         : TColor;       //2.Farbe des Focusrahmens
    FOrientation         : TOrientation; //Ausrichtung des Schiebers
    FTrack               : TTrack;       //Spur,Schlitz,Slot
    FReversed            : boolean;      // MinMax umgekehrt
    procedure SetKnob(const aValue : TKnob);
    procedure SetKnobColor(const aColor:TColor);
    procedure SetKnobLook(const aValue : TLook);
    procedure SetLookColor(const aColor:TColor);
    procedure SetBackgroundColor(const aColor:TColor);
    procedure SetBorderColor(const aColor:TColor);
    procedure SetBorderWidth(const aValue:integer);
    procedure SetMin(const aValue:integer);
    procedure SetMax(const aValue:integer);
    procedure SetStep(const aValue:integer);
    procedure setPosition(const aValue:integer);
    procedure SetFocusColor1(const aColor:TColor);
    procedure SetFocusColor2(const aColor:TColor);
    procedure SetOrientation(const aValue : TOrientation);
    procedure SetReversed(const Value : boolean);
  protected
    { Protected declarations,geschützte Deklarationen }
    FakY           : double;
    MitteY         : double;
    Knopf          : TRect;
    MKnob          : integer;
    Knopf2         : TRect;
    MKnob2         : integer;
    Knopf3         : TRect;
    MKnob3         : integer;
    links,rechts   : integer;
    Skala          : integer;
    Schritte       : integer;
    schieben       : boolean;
    schieben2      : boolean;
    schieben3      : boolean;
    PixelSchritt   : double;
    zaehler        : integer;
    versatz        : integer;
    Mark1          : array [0..2] of TPoint;
    Mark2          : array [0..2] of TPoint;
    selektiert     : boolean;
    extra          : boolean;
    Pfeil          : array [0..2] of TPoint;
    Pfeil1         : array [0..4] of TPoint;
    geaendert      : Boolean;
    tmpcolor       : TColor;

    procedure Loaded; override;
    procedure mousemove(Shift: TShiftState; X, Y: Integer);override;
    procedure MouseDown(Button: TMouseButton;Shift: TShiftState; X, Y: Integer);override;
    procedure MouseUp(Button: TMouseButton;Shift: TShiftState; X, Y: Integer);override;
    procedure CNKeyDown    (var Message: TLMKeyDown);    message CN_KEYDOWN;  // Siro
    procedure DoExit;  override;  // wenn die Komponente den Focus verliert 13.04.2020 Siro
    procedure DoEnter; override;  // wenn die Komponente den Focus erhält   13.04.2020 Siro

  public
    { Public declarations, öffentliche Deklarationen, nicht sichtbar im OI }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;
    property Step                : integer read FStep           write SetStep default 1;
    property FocusColor1         : TColor  read FFocusColor1    write SetFocusColor1 default clblue;
    property FocusColor2         : TColor  read FFocusColor2    write SetFocusColor2 default clblack;
    property KnobLookColor       : TColor  read FLookColor      write SetLookColor default clsilver;
  published
    { Published declarations, veröffentlichte Deklarationen, sichtbar im OI }
   property KnobStyle          : TKnob   read fKnob                          write SetKnob default kscircle;
   property KnobLook           : TLook   read FLook                          write SetKnobLook default klNormal;
   property BackgroundColor    : TColor  read FBackgroundColor               write SetBackgroundColor default clMenuBar;
   property KnobColor          : TColor  read FKnobColor                     write SetKnobColor default clblack;
   property BorderColor        : TColor  read FBorderColor                   write SetBorderColor default clgray;
   property BorderWidth        : integer read FBorderWidth                   write SetBorderWidth default 1;
   property RangeMin           : integer read FMin                           write SetMin default 0;
   property RangeMax           : integer read FMax                           write SetMax default 10;
   property Position           : integer read FPosition                      write setPosition default 0;
   property OnChange           : TChangeEvent read FOnChange                 write FOnChange;
   property Scale              : TScale  read FScale                         write FScale;
   property Mark               : TMark   read FMark                          write FMark;
   property Indicator          : TIndicator   read FIndicator                write FIndicator;
   property MultiKnob          : TMultiKnob   read FMultiKnob                write FMultiKnob;
   property Orientation        : TOrientation read FOrientation              write SetOrientation default scHorizontal;
   property Track              : TTrack  read FTrack                         write FTrack;
   property Reversed           : boolean read FReversed                      write SetReversed default false;
   property TabStop default TRUE;   // 13.03.2020 Siro
end;


procedure Register;

implementation

constructor TSliderComponent.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  width                 := 200;
  height                :=  30;
  if FOrientation = scVertical then
   begin
    width                 :=  30;
    height                := 200;
   end;
  FKnob                 := kscircle;
  FBackgroundColor      := clMenuBar;
  FKnobColor            := clblack;
  FBorderColor          := clgray;
  FBorderWidth          :=   1;
  FMin                  :=   0;
  FMax                  :=  10;
  FStep                 :=   1;
  FPosition             :=   0;
  FFocusColor1          := clblue;
  FFocusColor2          := clblack;
  FOrientation          := scHorizontal;
  FReversed             := false;
  FLook                 := klNormal;
  FLookColor            := clsilver;

  FScale := TScale.Create(self);
  FScale.FLineColor:=clblack;
  FScale.FMarkColor:=clnavy;
  FScale.FInterval:=2;
  FScale.FShowScale:=false;
  FScale.FOtherSide:=false;
  FScale.FBigMarkColor:=clNavy;
  FScale.FBigMarkInterval:= 5;
  FScale.FShowBigMark:= false;
  FScale.FBigMarkSize:=1.5;

  FMark                 := TMark.Create(self);     // Siro, Besitzer übergeben ist die Komponenten selber
  FMark.FMarkVisible    := false;
  FMark.FMarkColor      := clNavy;
  FMark.FMarkPosition   := 0;
  FMark.FMark2Visible   := false;
  FMark.FMark2Position  := 0;

  FIndicator                       := TIndicator.Create(self);  // Siro, Besitzer ist die Komponente selber
  FIndicator.FIndicatorVisible     := false;
  FIndicator.FIndicatorColor       := clMoneyGreen;
  FIndicator.FIndicatorFontColor   := clblack;

  FMultiKnob                := TMultiKnob.Create(self);     // Siro, Besitzer ist die Komponente selber
  FMultiKnob.FShowKnob2     := false;
  FMultiKnob.FShowKnob3     := false;
  FMultiKnob.FColorKnob2    := cllime;
  FMultiKnob.FColorKnob3    := clblue;
  FMultiKnob.FPosKnob2      :=  5;
  FMultiKnob.FPosKnob3      := 10;

  FTrack                       := TTrack.create(self);
  FTrack.FSlotColor            := clWhite;
  FTrack.FSlotColorSel         := clGray;
  FTrack.FSlotColorSelVisible  := true;
  FTrack.FSlotColorExt         := clred;
  FTrack.FSlotColorExtVisible  := false;
  FTrack.FExtMin               := 0;
  FTrack.FExtMax               := 0;

  schieben              := false;
  geaendert             := false;

  TabStop:=TRUE;    // 13.04.2020 Siro

end;

destructor TSliderComponent.Destroy;
begin
 FScale.Free;
 FMark.Free;
 FIndicator.Free;
 FMultiKnob.Free;
 FTrack.Free;
 inherited Destroy;
end;

//  --- SIRO --------------------------------------------------------
// Damit der Fokus bei Cursortasten nicht an andere Komponenten weitergegeben wird,
// werden die Tasten hier lediglich abgefangen und als bearbeitet markiert
// indem das Message.result auf 1 gesetzt wird.
// Alle Tasten welche die Komponente für sich beansprucht müssen in
// die case Auswahl mit aufgeführt werden.
procedure TSliderComponent.CNKeyDown(var Message: TLMKeyDown);
begin
 if ((FOrientation=scHorizontal) and (not Reversed)) then
  begin
   with Message do begin
    Result := 1;          { wir gehen davon aus daß die Message verarbeitet wird }
    case CharCode of
        VK_LEFT  : if Position > RangeMin then Position:=Position-1;  // Cursor Left
        VK_RIGHT : if Position < RangeMax then Position:=Position+1;  // Cursor Right
        VK_HOME  : Position:=0;  // Cursor Home
        VK_END   : Position:=RangeMax;  // Cursor End
//        VK_TAB   : ;  // hebelt TabStop aus.......Tab soll aber den Focus weiter reichen
      else begin
        Result := 0;     { message wurde nicht verarbeitet }
      end; {else}
    end; { case }
   end; { with }
  end;
 if ((FOrientation=scHorizontal) and (Reversed)) then
  begin
   with Message do begin
    Result := 1;          { wir gehen davon aus daß die Message verarbeitet wird }
    case CharCode of
        VK_Right : if Position > RangeMin then Position:=Position-1;  // Cursor Left
        VK_Left  : if Position < RangeMax then Position:=Position+1;  // Cursor Right
        VK_HOME  : Position:=0;  // Cursor Home
        VK_END   : Position:=RangeMax;  // Cursor End
//        VK_TAB   : ;  // hebelt TabStop aus.......Tab soll aber den Focus weiter reichen
      else begin
        Result := 0;     { message wurde nicht verarbeitet }
      end; {else}
    end; { case }
   end; { with }
  end;
 if ((FOrientation = scVertical) and (not Reversed)) then
  begin
   with Message do begin
    Result := 1;          { wir gehen davon aus daß die Message verarbeitet wird }
    case CharCode of
        VK_Up  : if Position > RangeMin then Position:=Position-1;  // Cursor Left
        VK_Down : if Position < RangeMax then Position:=Position+1;  // Cursor Right
        VK_HOME  : Position:=0;  // Cursor Home
        VK_END   : Position:=RangeMax;  // Cursor End
//        VK_TAB   : ;  // hebelt TabStop aus.......Tab soll aber den Focus weiter reichen
      else begin
        Result := 0;     { message wurde nicht verarbeitet }
      end; {else}
    end; { case }
   end; { with }
  end;
 if ((FOrientation = scVertical) and (Reversed)) then
  begin
   with Message do begin
    Result := 1;          { wir gehen davon aus daß die Message verarbeitet wird }
    case CharCode of
        VK_Down  : if Position > RangeMin then Position:=Position-1;  // Cursor Left
        VK_Up    : if Position < RangeMax then Position:=Position+1;  // Cursor Right
        VK_HOME  : Position:=0;  // Cursor Home
        VK_END   : Position:=RangeMax;  // Cursor End
//        VK_TAB   : ;  // hebelt TabStop aus.......Tab soll aber den Focus weiter reichen
      else begin
        Result := 0;     { message wurde nicht verarbeitet }
      end; {else}
    end; { case }
   end; { with }
  end;

 inherited; // Vorgaenger immer aufrufen, jedoch mit dem entsprechendem Result
end;


constructor TScale.create(aOwner:TCustomControl);  // Siro neuer Constructor mit Parameter des Besitzers
begin
 FOwner:=aOwner;
 inherited create;  // Siro
end;

procedure TScale.SetLineColor(const aColor:TColor);
begin
 if aColor = FLineColor then exit;
 FLineColor:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TScale.SetMarkColor(const aColor:TColor);
begin
 if aColor = FMarkColor then exit;
 FMarkColor:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TScale.SetInterval(const aValue:integer);
begin
 if aValue = FInterval then exit;
 FInterval:=AValue;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TScale.SetShowScale(const Value:boolean);
begin
 if Value = FShowScale then exit;
 FShowScale := Value;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TScale.SetOtherSide(const Value:boolean);
begin
 if Value = FOtherSide then exit;
 FOtherSide := Value;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TScale.SetBigMarkColor(const aColor:TColor);
begin
 if aColor = FBigMarkColor then exit;
 FBigMarkColor:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TScale.SetBigMarkInterval(const aValue:integer);
begin
 if aValue = FBigMarkInterval then exit;
 FBigMarkInterval:=AValue;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TScale.SetShowBigMark(const Value:boolean);
begin
 if Value = FShowBigMark then exit;
 FShowBigMark := Value;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TScale.SetBigMarkSize(const aValue:double);
begin
 if aValue = FBigMarkSize then exit;
 FBigMarkSize:=AValue;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TSliderComponent.SetKnob(const aValue : TKnob);
begin
 if fKnob <> aValue then
 begin
  fKnob := aValue;
  Invalidate;
 end;
end;

procedure TSliderComponent.SetKnobLook(const aValue : TLook);
begin
 if fLook <> aValue then
 begin
  fLook := aValue;
  Invalidate;
 end;
end;

procedure TSliderComponent.SetLookColor(const aColor : TColor);
begin
 if fLookColor <> aColor then
 begin
  fLookColor := aColor;
  Invalidate;
 end;
end;

procedure TSliderComponent.SetBackgroundColor(const aColor:TColor);
begin
 if aColor = FBackgroundColor then exit;
 FBackgroundColor:=aColor;
 Invalidate;
end;

constructor TTrack.create(aOwner:TCustomControl);
begin
 FOwner:=aOwner;
 inherited create;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TTrack.SetSlotColor(const aColor:TColor);
begin
 if aColor = FSlotColor then exit;
 FSlotColor:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TTrack.SetSlotColorSelVisible(const Value:boolean);
begin
 if FSlotColorSelVisible = Value then exit;
 FSlotColorSelVisible   := Value;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TTrack.SetSlotColorSel(const aColor:TColor);
begin
 if aColor = FSlotColorSel then exit;
 FSlotColorSel:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TTrack.SetSlotColorExtVisible(const Value:boolean);
begin
 if FSlotColorExtVisible = Value then exit;
 FSlotColorExtVisible   := Value;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TTrack.SetSlotColorExt(const aColor:TColor);
begin
 if aColor = FSlotColorExt then exit;
 FSlotColorExt:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TTrack.SetExtMin(const aValue:integer);
begin
 if FExtMin = aValue then exit;
 FExtMin:=aValue;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TTrack.SetExtMax(const aValue:integer);
begin
 if FExtMax = aValue then exit;
 FExtMax:=aValue;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

procedure TSliderComponent.SetKnobColor(const aColor:TColor);
begin
 if aColor = FKnobColor then exit;
 FKnobColor:=aColor;
 Invalidate;
end;

procedure TSliderComponent.SetBorderColor(const aColor:TColor);
begin
 if aColor = FBorderColor then exit;
 FBorderColor:=aColor;
 Invalidate;
end;

procedure TSliderComponent.SetBorderWidth(const aValue:integer);
begin
 if aValue = FBorderWidth then exit;
 FBorderWidth:=aValue;
 Invalidate;
end;

procedure TSliderComponent.SetMin(const aValue:integer);
begin
 if aValue = FMin then exit;
 if aValue > FMax then
  begin
   //showmessage('min>max');
   exit;
  end;
 FMin:=aValue;
 Invalidate;
end;

procedure TSliderComponent.SetMax(const aValue:integer);
begin
 if aValue = FMax then exit;
 if aValue < FMin then
  begin
   //showmessage('max<min');
   exit;
  end;
 FMax:=aValue;
 Invalidate;
end;

procedure TSliderComponent.SetStep(const aValue:integer);
begin
 if aValue = FStep then exit;
 FStep:=aValue;
 Invalidate;
end;

procedure TSliderComponent.setPosition(const aValue:integer);
begin
 if aValue = FPosition then exit;
 FPosition:=aValue;
 if FPosition < FMin then FPosition := FMin;
 if FPosition > FMax then FPosition := FMax;
 if Assigned(OnChange) then OnChange(Position);
 Invalidate;
end;

constructor TIndicator.create(aOwner:TCustomControl);  // Siro neuer Constructor mit Parameter des Besitzers
begin
 FOwner:=aOwner;
 inherited create;  // Siro
end;

procedure TIndicator.SetIndicatorVisible(const Value:boolean);
begin
 if FIndicatorVisible =Value then exit;
 FIndicatorVisible :=Value;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TIndicator.SetIndicatorColor(const aColor:TColor);
begin
 if FIndicatorColor=aColor then exit;
 FIndicatorColor:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TIndicator.SetIndicatorFontColor(const aColor:TColor);
begin
 if FIndicatorFontColor=aColor then exit;
 FIndicatorFontColor:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

constructor TMark.create(aOwner:TCustomControl);  // Siro neuer Constructor mit Parameter des Besitzers
begin
 FOwner:=aOwner;
 inherited create;  // Siro
end;

procedure TMark.SetMarkVisible(const Value:boolean);
begin
 if FMarkVisible =Value then exit;
 FMarkVisible :=Value;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TMark.SetMarkColor(const aColor:TColor);
begin
 if FMarkColor=aColor then exit;
 FMarkColor:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TMark.SetMarkPosition(const aValue:integer);
begin
 if FMarkPosition = aValue then exit;
 FMarkPosition := aValue;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TMark.SetMark2Visible(const Value:boolean);
begin
 if FMark2Visible = Value then exit;
 FMark2Visible :=Value;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TMark.SetMark2Position(const aValue:integer);
begin
 if FMark2Position = aValue then exit;
 FMark2Position := aValue;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

constructor TMultiKnob.create(aOwner:TCustomControl);      //  Siro neuer Constructor mit Parameter des Besitzers
begin
 FOwner:=aOwner;
 inherited create;
end;

procedure TMultiKnob.SetShowKnob2(const Value:boolean);
begin
 if fShowKnob2 = Value then exit;
 fShowKnob2 :=Value;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TMultiKnob.SetShowKnob3(const Value:boolean);
begin
 if fShowKnob3 = Value then exit;
 fShowKnob3 :=Value;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TMultiKnob.SetColorKnob2(const aColor:TColor);
begin
 if fColorKnob2=aColor then exit;
 fColorKnob2:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TMultiKnob.SetColorKnob3(const aColor:TColor);
begin
 if fColorKnob3=aColor then exit;
 fColorKnob3:=aColor;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TMultiKnob.SetPosKnob2(const aValue:integer);
begin
 if FPosKnob2 = aValue then exit;
 FPosKnob2 := aValue;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TMultiKnob.SetPosKnob3(const aValue:integer);
begin
 if FPosKnob3 = aValue then exit;
 FPosKnob3 := aValue;
 if Assigned(FOwner) then FOwner.Invalidate; // wenn Besitzer existiert, sien Invalidate aufrufen
end;

procedure TSliderComponent.SetFocusColor1(const aColor:TColor);
begin
 if FFocusColor1=aColor then exit;
 FFocusColor1:=aColor;
 Invalidate
end;

procedure TSliderComponent.SetFocusColor2(const aColor:TColor);
begin
 if FFocusColor2=aColor then exit;
 FFocusColor2:=aColor;
 Invalidate
end;


procedure TSliderComponent.SetOrientation(const aValue : TOrientation);
var wi,he : integer;
begin
 //if (csLoading in ComponentState) then   //machts nur beim ersten Start
 if FOrientation = aValue then exit;
 FOrientation := aValue;
 if width<height then
  begin
   wi := height;
   he := width;
  end else
  begin
   wi:= width;
   he:= height;
  end;
 if FOrientation = scVertical then
  begin
   width := he;
   height:= wi;
  end else
  begin
   width := wi;
   height:= he;
  end;
 Invalidate;
end;

procedure TSliderComponent.SetReversed(const Value:boolean);
begin
 if FReversed=Value then exit;
 FReversed:=Value;
 Invalidate
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX----ENDE DER SET PROZEDUREN----XXXXXXXXXXXX}

procedure TSliderComponent.MouseDown(Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
var P1        : TPoint;
    h,w,kl,kr : integer;
begin
 SetFocus;  // Siro
  P1.X:=x;
  P1.Y:=y;
  h:= height;
  Kl:=Knopf.Left;
  Kr:=Knopf.Right;
 if FOrientation = scVertical then
  begin
   h:=width;
   w:=height;
   Kl:=Knopf.Top;
   Kr:=Knopf.Bottom;
  end;
  if ptinrect(Knopf,P1) then schieben:=true;
  if (ptinrect(Knopf2,P1)) and (schieben=false) then schieben2:=true;
  if (ptinrect(Knopf3,P1)) and (schieben=false) and (schieben2=false) then schieben3:=true;
  if (schieben=false) and (schieben2=false) and (schieben3=false) and (FOrientation <> scVertical) then
   begin
    if ptinrect(rect(0,0,Kl,h),P1) then
     begin
      Position:= Position - FStep;
      Invalidate;
     end;
    if ptinrect(rect(Kr,0,w,h),P1) then
     begin
      Position:= Position + FStep;
      Invalidate;
     end;
   end;
  if (schieben=false) and (schieben2=false) and (schieben3=false) and (FOrientation = scVertical) then
   begin
    if ptinrect(rect(0,0,h,Kl),P1) then
     begin
      Position:= Position - FStep;
      Invalidate;
     end;
    if ptinrect(rect(0,Kr,h,w),P1) then
     begin
      Position:= Position + FStep;
      Invalidate;
     end;
   end;
end;

procedure TSliderComponent.mousemove(Shift: TShiftState; X, Y: Integer);
var lv,w:integer;
begin
  // SetFocus;  // je nach Bedarf kann hier auch der Focus aktiviert werden Siro
  w:=width;
  if FOrientation = scVertical then
  begin
   lv:=x;
   x :=y;
   y :=lv;
   w:=height;
  end;
 if schieben then
  begin
   for lv:= FMin to FMax do
    begin
     if not Reversed then
      begin
       if (x>=links+round(Pixelschritt*(lv-versatz))) and (x<links+round(Pixelschritt*(lv+1-versatz))) then Position:=lv;
       if x > w-round(FakY*8) then Position:=FMax;
       if x < round(FakY*8) then Position:=FMin;
      end else
      begin
       if (x<=rechts-round(Pixelschritt*(lv-versatz))) and (x>rechts-round(Pixelschritt*(lv+1-versatz))) then Position:=lv;
       if x > w-round(FakY*8) then Position:=FMin;
       if x < round(FakY*8) then Position:=FMax;
      end;
    end;
   //if Assigned(OnChange) then OnChange(Position);
   Invalidate;
  end;
 if schieben2 then
  begin
   for lv:= FMin to FMax do
    begin
     if not Reversed then
      begin
       if (x>=links+round(Pixelschritt*(lv-versatz))) and (x<links+round(Pixelschritt*(lv+1-versatz))) then FMultiKnob.FPosKnob2:=lv;
       if x > w-round(FakY*8) then FMultiKnob.FPosKnob2:=FMax;
       if x < round(FakY*8) then FMultiKnob.FPosKnob2:=FMin;
      end else
      begin
       if (x<=rechts-round(Pixelschritt*(lv-versatz))) and (x>rechts-round(Pixelschritt*(lv+1-versatz))) then FMultiKnob.FPosKnob2:=lv;
       if x > w-round(FakY*8) then FMultiKnob.FPosKnob2:=FMin;
       if x < round(FakY*8) then FMultiKnob.FPosKnob2:=FMax;
      end;
    end;
   if Assigned(OnChange) then OnChange(Position);
   Invalidate;
  end;
 if schieben3 then
  begin
   for lv:= FMin to FMax do
    begin
     if not Reversed then
      begin
       if (x>=links+round(Pixelschritt*(lv-versatz))) and (x<links+round(Pixelschritt*(lv+1-versatz))) then FMultiKnob.FPosKnob3:=lv;
       if x > w-round(FakY*8) then FMultiKnob.FPosKnob3:=FMax;
       if x < round(FakY*8) then FMultiKnob.FPosKnob3:=FMin;
      end else
      begin
       if (x<=rechts-round(Pixelschritt*(lv-versatz))) and (x>rechts-round(Pixelschritt*(lv+1-versatz))) then FMultiKnob.FPosKnob3:=lv;
       if x > w-round(FakY*8) then FMultiKnob.FPosKnob3:=FMin;
       if x < round(FakY*8) then FMultiKnob.FPosKnob3:=FMax;
      end;
    end;
   if Assigned(OnChange) then OnChange(Position);
   Invalidate;
  end;
end;

procedure TSliderComponent.MouseUp(Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
begin
 if schieben  then schieben  :=false;
 if schieben2 then schieben2 :=false;
 if schieben3 then schieben3 :=false;

end;


procedure TSliderComponent.DoEnter; // erhält den Focus 13.04.2020 Siro
begin
  invalidate;  // Neu zeichnen mit Focus
  inherited;
end;

procedure TSliderComponent.DoExit; // verliert den Focus 13.04.2020 Siro
begin
  invalidate;  // Neu zeichnen, jetzt ohne Focus
  inherited;
end;

procedure TSliderComponent.Loaded;
var temp : integer;
begin
  inherited;
 if FMin > FMax then
  begin
   temp:=FMin;
   FMin:=FMax;
   FMax:=temp;
  end;
 if Position<FMin then Position := FMin;
 if Position>FMax then Position := FMax;
 //Orientation := FOrientation;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX----AB HIER PAINT----XXXXXXXXXXXXXXXXXXXXXXXXX}

procedure TSliderComponent.Paint;
var lv,ExtL,ExtR,temp : integer;
    ScMark            : TRect;
    x1,x2,y1,y2       : integer;
    bigfak            : double;
begin
 canvas.Pen.Width  := 1;
                  //xxxxxxxxxxxxxxxxxxxx---HORIZONTAL---XXXXXXXXXXX
if FOrientation = scHorizontal then
begin
 FakY   := height / 30;
 MitteY := height / 2;

 links  := round((FakY*8)+(6*FakY));          //linkes Ende der Skala
 rechts := width-round(((FakY*8)+(6*FakY)));  //rechtes Ende der Skala
 Skala  := rechts-links;                      //Länge Skala
 {Positiverbereich 0 bis ..}
 if FMin >=0 then
  begin
   Schritte:= (FMax-FMin);
  end;
 {Negativerbereich }
 if FMax <=0 then
  begin
   Schritte:= (FMax-FMin);
  end;
 {Um 0 }
 if (FMin <0)  and (FMax>0) then
  begin
   Schritte:= (0-FMin)+FMax;
  end;
 Pixelschritt:= Skala/Schritte;
 versatz:=0+FMin;
//Mitte des Knopfes bestimmen
if not Reversed then
 begin
  for lv:= FMin to FMax do
   begin
    if lv= FPosition then MKnob:= links+round(Pixelschritt*(lv-versatz));
   end;
  for lv:= FMin to FMax do
   begin
    if lv= FMultiKnob.FPosKnob2 then MKnob2:= links+round(Pixelschritt*(lv-versatz));
   end;
  for lv:= FMin to FMax do
   begin
    if lv= FMultiKnob.FPosKnob3 then MKnob3:= links+round(Pixelschritt*(lv-versatz));
   end;
  end;
if Reversed then
 begin
  for lv:= FMin to FMax do
   if lv= FPosition then MKnob:= rechts-round(Pixelschritt*(lv-versatz));
  for lv:= FMin to FMax do
   if lv= FMultiKnob.FPosKnob2 then MKnob2:= rechts-round(Pixelschritt*(lv-versatz));
  for lv:= FMin to FMax do
   if lv= FMultiKnob.FPosKnob3 then MKnob3:= rechts-round(Pixelschritt*(lv-versatz));
  end;
 Knopf := rect(round(MKnob-(6*FakY)),round(MitteY-(6*FakY)),round(MKnob+(6*FakY)),round(MitteY+(6*FakY)));
 Knopf := rect(Knopf.Left-1,Knopf.Top-1,Knopf.Right+1,Knopf.Bottom+1);

 Knopf2 := rect(round(MKnob2-(6*FakY)),round(MitteY-(6*FakY)),round(MKnob2+(6*FakY)),round(MitteY+(6*FakY)));
 Knopf2 := rect(Knopf2.Left-1,Knopf2.Top-1,Knopf2.Right+1,Knopf2.Bottom+1);

 Knopf3 := rect(round(MKnob3-(6*FakY)),round(MitteY-(6*FakY)),round(MKnob3+(6*FakY)),round(MitteY+(6*FakY)));
 Knopf3 := rect(Knopf3.Left-1,Knopf3.Top-1,Knopf3.Right+1,Knopf3.Bottom+1);


//Hintergrund
 temp              := canvas.Pen.Width;
 canvas.Pen.Width  := FBorderWidth;
 canvas.Pen.Color  := FBorderColor;
 canvas.Brush.Color:=FBackgroundColor;
 canvas.Rectangle(0,0,width,height);
 canvas.Pen.Width  := temp;
//Schiebenut,Track
 canvas.Pen.Color  := FTrack.FSlotColor;
 canvas.Brush.Color:= FTrack.FSlotColor;
 canvas.Rectangle(round(FakY*8),round(MitteY-(3*FakY)),width-round(FakY*8),round(MitteY+(3*FakY)));

 if FTrack.FSlotColorExtVisible then         //Extrafarbe
  begin
   canvas.Pen.Color  := FTrack.FSlotColorExt;
   canvas.Brush.Color:= FTrack.FSlotColorExt;

   for lv:= FMin to FMax do
    begin
     if not Reversed then
      begin
       if lv= FTrack.FExtMin then ExtL:= links+round(Pixelschritt*(lv-versatz));
       if lv= FTrack.FExtMax then ExtR:= links+round(Pixelschritt*(lv-versatz));
      end  else
      begin
       if lv= FTrack.FExtMin then ExtR:= rechts-round(Pixelschritt*(lv-versatz));
       if lv= FTrack.FExtMax then ExtL:= rechts-round(Pixelschritt*(lv-versatz));
      end;
    end;
   canvas.Rectangle(ExtL,round(MitteY-(3*FakY)),ExtR,round(MitteY+(3*FakY)));
   if not Reversed then
      begin
       if FTrack.FExtMin = fmin then canvas.Rectangle(round(FakY*8),round(MitteY-(3*FakY)),ExtR,round(MitteY+(3*FakY)));
       if FTrack.FExtMax = fmax then canvas.Rectangle(ExtL,round(MitteY-(3*FakY)),width-round(FakY*8),round(MitteY+(3*FakY)));
      end else
      begin
       if FTrack.FExtMax = fmax then canvas.Rectangle(round(FakY*8),round(MitteY-(3*FakY)),ExtL,round(MitteY+(3*FakY)));
       if FTrack.FExtMin = fmin then canvas.Rectangle(ExtR,round(MitteY-(3*FakY)),width-round(FakY*8),round(MitteY+(3*FakY)));
      end;
  end;


 if FTrack.FSlotColorSelVisible then      //SelectedColor
  begin
   canvas.Pen.Color  := FTrack.FSlotColorSel;
   canvas.Brush.Color:= FTrack.FSlotColorSel;
   if not Reversed then
    begin
     if (FMax<=0) then canvas.Rectangle(MKnob,round(MitteY-(3*FakY)),width-round(FakY*8),round(MitteY+(3*FakY)))
     else canvas.Rectangle(round(FakY*8),round(MitteY-(3*FakY)),MKnob,round(MitteY+(3*FakY)));
    end else
    begin
     if (FMax<=0) then canvas.Rectangle(MKnob,round(MitteY-(3*FakY)),round(FakY*8),round(MitteY+(3*FakY)))
     else canvas.Rectangle(rechts+round(FakY*6),round(MitteY-(3*FakY)),MKnob,round(MitteY+(3*FakY)));
    end;
   canvas.Pen.Color  := FTrack.FSlotColor;
   canvas.Brush.Color:= FTrack.FSlotColor;
  end;


 if FScale.FShowScale then      //Skala
  begin
   canvas.Pen.Color   :=FScale.FLineColor;
   if not FScale.FOtherSide then
   canvas.Line(links,Knopf.Bottom+round(3*FakY),rechts,Knopf.Bottom+round(3*FakY))
   else
   canvas.Line(links,Knopf.Top-round(3*FakY),rechts,Knopf.Top-round(3*FakY));

   canvas.Pen.Color   :=FScale.FMarkColor;    //kleine Markierungen
   canvas.Brush.Color :=FScale.FMarkColor;
   if not FScale.OtherSide then
    begin
     ScMark             := rect(links-round(2*FakY),(Knopf.Bottom+round(3*FakY))-round(2*FakY),links+round(2*FakY),(Knopf.Bottom+round(3*FakY))+round(2*FakY));
     for lv:= 0 to round((FMax-FMin)/FScale.FInterval)-1 do
     Canvas.Ellipse(SCMark.Left+round(Pixelschritt*lv*FScale.FInterval),SCMark.Top,SCMark.Right+round(Pixelschritt*lv*FScale.FInterval),SCMark.Bottom);
     Canvas.Ellipse((SCMark.Left+rechts)-links,SCMark.Top,(SCMark.Right+rechts)-links,SCMark.Bottom);
    end else
    begin
     ScMark := rect(links-round(2*FakY),(Knopf.Top-round(3*FakY))-round(2*FakY),links+round(2*FakY),(Knopf.Top-round(3*FakY))+round(2*FakY));
     for lv:= 0 to round((FMax-FMin)/FScale.FInterval)-1 do
     Canvas.Ellipse(SCMark.Left+round(Pixelschritt*lv*FScale.FInterval),SCMark.Top,SCMark.Right+round(Pixelschritt*lv*FScale.FInterval),SCMark.Bottom);
     Canvas.Ellipse((SCMark.Left+rechts)-links,SCMark.Top,(SCMark.Right+rechts)-links,SCMark.Bottom);
    end;

 if FScale.FShowBigMark then
  begin
   bigfak:= 2*FScale.FBigMarkSize;
   canvas.Pen.Color   :=FScale.FBigMarkColor;    //Big Marks
   canvas.Brush.Color :=FScale.FBigMarkColor;
   if not FScale.OtherSide then
    begin
     ScMark             := rect(links-round(bigfak*FakY),(Knopf.Bottom+round(3*FakY))-round(bigfak*FakY),links+round(bigfak*FakY),(Knopf.Bottom+round(3*FakY))+round(bigfak*FakY));
     for lv:= 0 to round((FMax-FMin)/FScale.FBigMarkInterval)-1 do
     Canvas.Ellipse(SCMark.Left+round(Pixelschritt*lv*FScale.FBigMarkInterval),SCMark.Top,SCMark.Right+round(Pixelschritt*lv*FScale.FBigMarkInterval),SCMark.Bottom);
     Canvas.Ellipse((SCMark.Left+rechts)-links,SCMark.Top,(SCMark.Right+rechts)-links,SCMark.Bottom);
    end else
    begin
     ScMark := rect(links-round(bigfak*FakY),(Knopf.Top-round(3*FakY))-round(bigfak*FakY),links+round(bigfak*FakY),(Knopf.Top-round(3*FakY))+round(bigfak*FakY));
     for lv:= 0 to round((FMax-FMin)/FScale.FBigMarkInterval)-1 do
     Canvas.Ellipse(SCMark.Left+round(Pixelschritt*lv*FScale.FBigMarkInterval),SCMark.Top,SCMark.Right+round(Pixelschritt*lv*FScale.FBigMarkInterval),SCMark.Bottom);
     Canvas.Ellipse((SCMark.Left+rechts)-links,SCMark.Top,(SCMark.Right+rechts)-links,SCMark.Bottom);
    end;
  end;
  end;

 //Position der Markierung
 for lv:= FMin to FMax do
   begin
    if lv= FMark.FMarkPosition then
     begin
      if not Reversed then
       begin
        Mark1[0]:=Point(links+round(Pixelschritt*(lv-versatz)),Knopf.Bottom);
        Mark1[1]:=Point(Mark1[0].X+round(5*FakY),Knopf.Bottom+round(5*FakY));
        Mark1[2]:=Point(Mark1[0].X-round(5*FakY),Knopf.Bottom+round(5*FakY));
       end else
       begin
        Mark1[0]:=Point(rechts-round(Pixelschritt*(lv-versatz)),Knopf.Bottom);
        Mark1[1]:=Point(Mark1[0].X+round(5*FakY),Knopf.Bottom+round(5*FakY));
        Mark1[2]:=Point(Mark1[0].X-round(5*FakY),Knopf.Bottom+round(5*FakY))
       end;
     end;
   end;
 for lv:= FMin to FMax do         //Position der 2.Markierung
   begin
    if lv= FMark.FMark2Position then
     begin
      if not Reversed then
       begin
        Mark2[0]:=Point(links+round(Pixelschritt*(lv-versatz)),Knopf.Bottom);
        Mark2[1]:=Point(Mark2[0].X+round(5*FakY),Knopf.Bottom+round(5*FakY));
        Mark2[2]:=Point(Mark2[0].X-round(5*FakY),Knopf.Bottom+round(5*FakY));
       end else
       begin
        Mark2[0]:=Point(rechts-round(Pixelschritt*(lv-versatz)),Knopf.Bottom);
        Mark2[1]:=Point(Mark2[0].X+round(5*FakY),Knopf.Bottom+round(5*FakY));
        Mark2[2]:=Point(Mark2[0].X-round(5*FakY),Knopf.Bottom+round(5*FakY));
       end;
     end;
   end;
 if FMark.FMarkVisible then    //Markierung
  begin
   canvas.Pen.Color  := FMark.FMarkColor;
   canvas.Brush.Color:= FMark.FMarkColor;
   canvas.Line(MKnob,round(MitteY),MKnob,Knopf.Bottom); //Markierung im SchiebeKnopf
   canvas.Polygon(Mark1);
  end;
 if FMark.FMark2Visible then    //2.Markierung
  begin
   canvas.Pen.Color  := FMark.FMarkColor;
   canvas.Brush.Color:= FMark.FMarkColor;
   canvas.Polygon(Mark2);
  end;



//SchiebeKnopf3
if FMultiKnob.FShowKnob3 then
 begin
  if FLook = klNormal then canvas.Pen.Color  := FMultiKnob.ColorKnob3
  else canvas.Pen.Color  := FLookColor;

  canvas.Brush.Color:= FMultiKnob.ColorKnob3;
  if FKnob = ksrectangle then
   begin
    if FLook = klNormal then canvas.Rectangle(Knopf3);
    if FLook = klRipped then
    begin
     canvas.Rectangle(Knopf3);
     canvas.Rectangle(Knopf3.Left+round(3*FakY),Knopf3.Top+round(3*FakY),Knopf3.Right-round(3*FakY),Knopf3.Bottom-round(3*FakY));
     canvas.line(Knopf3.Left+round(5*FakY),Knopf3.Top+round(5*FakY),Knopf3.Left+round(5*FakY),Knopf3.Bottom-round(5*FakY));
     canvas.line(Knopf3.Right-round(5*FakY),Knopf3.Top+round(5*FakY),Knopf3.Right-round(5*FakY),Knopf3.Bottom-round(5*FakY));
    end;
   end;
  if FKnob = kscircle    then
   begin
   if FLook = klNormal then canvas.Ellipse(Knopf3);
   if FLook = klRipped then
    begin
     canvas.Ellipse(Knopf3);
     canvas.Ellipse(Knopf3.Left+round(3*FakY),Knopf3.Top+round(3*FakY),Knopf3.Right-round(3*FakY),Knopf3.Bottom-round(3*FakY));
    end;
  end;
  if FKnob = ksroundrect then
   begin
   if FLook = klNormal then canvas.RoundRect(Knopf3,round(4*FakY),round(4*FakY));
   if FLook = klRipped then
    begin
     canvas.RoundRect(Knopf3,round(4*FakY),round(4*FakY));
     canvas.RoundRect(rect(Knopf3.Left+round(3*FakY),Knopf3.Top+round(3*FakY),Knopf3.Right-round(3*FakY),Knopf3.Bottom-round(3*FakY)),round(4*FakY),round(4*FakY));
     canvas.line(Knopf3.Left+round(5*FakY),Knopf3.Top+round(5*FakY),Knopf3.Left+round(5*FakY),Knopf3.Bottom-round(5*FakY));
     canvas.line(Knopf3.Right-round(5*FakY),Knopf3.Top+round(5*FakY),Knopf3.Right-round(5*FakY),Knopf3.Bottom-round(5*FakY));
    end;
  end;
  if (FKnob = ksArrowUp) or (FKnob = ksArrowRight) then
   begin
    if FLook = klNormal then
    begin
    canvas.Rectangle(Rect(Knopf3.Left,Knopf3.Top,Knopf3.Right,Knopf3.Bottom));
    Pfeil[0].Y := Knopf3.Top;
    Pfeil[0].X := Knopf3.Left;
    Pfeil[1].X := MKnob3;
    Pfeil[1].Y := Knopf3.Top-(round(Knopf3.Width/4));
    Pfeil[2].X := Knopf3.Right-1;
    Pfeil[2].Y := Knopf3.Top;
    canvas.Polygon(Pfeil);
    end;

    if FLook = klRipped then
    begin
    Pfeil1[0].Y := Knopf3.Top;
    Pfeil1[0].X := Knopf3.Left;
    Pfeil1[1].X := MKnob3;
    Pfeil1[1].Y := Knopf3.Top-(round(Knopf3.Width/4));
    Pfeil1[2].X := Knopf3.Right;
    Pfeil1[2].Y := Knopf3.Top;
    Pfeil1[3].X := Knopf3.Right;
    Pfeil1[3].Y := Knopf3.Bottom;
    Pfeil1[4].X := Knopf3.Left;
    Pfeil1[4].Y := Knopf3.Bottom;

    canvas.Polygon(Pfeil1);
    canvas.Line(Knopf3.Left+round(5*FakY),Knopf3.Top+round(1.2*FakY),Knopf3.Left+round(5*FakY),Knopf3.Bottom-round(5*FakY));
    canvas.Line(Knopf3.Right-round(5*FakY),Knopf3.Top+round(1.2*FakY),Knopf3.Right-round(5*FakY),Knopf3.Bottom-round(5*FakY));
   end;
   end;
  if (FKnob = ksArrowDown) or (FKnob = ksArrowLeft) then
   begin
    if FLook = klNormal then
    begin
    canvas.Rectangle(Rect(Knopf3.Left,Knopf3.Top,Knopf3.Right,Knopf3.Bottom));
    Pfeil[0].Y := Knopf3.Bottom;
    Pfeil[0].X := Knopf3.Left;
    Pfeil[1].X := MKnob3;
    Pfeil[1].Y := Knopf3.Bottom+(round(Knopf3.Width/4));
    Pfeil[2].X := Knopf3.Right-1;
    Pfeil[2].Y := Knopf3.Bottom;
    canvas.Polygon(Pfeil);
    end;
    if FLook = klRipped then
    begin
    Pfeil1[0].Y := Knopf3.Bottom;
    Pfeil1[0].X := Knopf3.Left;
    Pfeil1[1].X := MKnob3;
    Pfeil1[1].Y := Knopf3.Bottom+(round(Knopf3.Width/4));
    Pfeil1[2].X := Knopf3.Right;
    Pfeil1[2].Y := Knopf3.Bottom;
    Pfeil1[3].X := Knopf3.Right;
    Pfeil1[3].Y := Knopf3.Top;
    Pfeil1[4].X := Knopf3.Left;
    Pfeil1[4].Y := Knopf3.Top;

    canvas.Polygon(Pfeil1);
    canvas.Line(Knopf3.Left+round(5*FakY),Knopf3.Top+round(5*FakY),Knopf3.Left+round(5*FakY),Knopf3.Bottom-round(1.2*FakY));
    canvas.Line(Knopf3.Right-round(5*FakY),Knopf3.Top+round(5*FakY),Knopf3.Right-round(5*FakY),Knopf3.Bottom-round(1.2*FakY));
    end;
   end;
 end;
//SchiebeKnopf2
if FMultiKnob.FShowKnob2 then
begin
 if FLook = klNormal then canvas.Pen.Color  := FMultiKnob.ColorKnob2
 else canvas.Pen.Color  := FLookColor;

canvas.Brush.Color:= FMultiKnob.ColorKnob2;
if FKnob = ksrectangle then
 begin
  if FLook = klNormal then canvas.Rectangle(Knopf2);
   if FLook = klRipped then
    begin
     canvas.Rectangle(Knopf2);
     canvas.Rectangle(Knopf2.Left+round(3*FakY),Knopf2.Top+round(3*FakY),Knopf2.Right-round(3*FakY),Knopf2.Bottom-round(3*FakY));
     canvas.line(Knopf2.Left+round(5*FakY),Knopf2.Top+round(5*FakY),Knopf2.Left+round(5*FakY),Knopf2.Bottom-round(5*FakY));
     canvas.line(Knopf2.Right-round(5*FakY),Knopf2.Top+round(5*FakY),Knopf2.Right-round(5*FakY),Knopf2.Bottom-round(5*FakY));
    end;
 end;
 if FKnob = kscircle    then
  begin
   if FLook = klNormal then canvas.Ellipse(Knopf2);
   if FLook = klRipped then
    begin
     canvas.Ellipse(Knopf2);
     canvas.Ellipse(Knopf2.Left+round(3*FakY),Knopf2.Top+round(3*FakY),Knopf2.Right-round(3*FakY),Knopf2.Bottom-round(3*FakY));
    end;
  end;
 if FKnob = ksroundrect then
  begin
   if FLook = klNormal then canvas.RoundRect(Knopf2,round(4*FakY),round(4*FakY));
   if FLook = klRipped then
    begin
     canvas.RoundRect(Knopf2,round(4*FakY),round(4*FakY));
     canvas.RoundRect(rect(Knopf2.Left+round(3*FakY),Knopf2.Top+round(3*FakY),Knopf2.Right-round(3*FakY),Knopf2.Bottom-round(3*FakY)),round(4*FakY),round(4*FakY));
     canvas.line(Knopf2.Left+round(5*FakY),Knopf2.Top+round(5*FakY),Knopf2.Left+round(5*FakY),Knopf2.Bottom-round(5*FakY));
     canvas.line(Knopf2.Right-round(5*FakY),Knopf2.Top+round(5*FakY),Knopf2.Right-round(5*FakY),Knopf2.Bottom-round(5*FakY));
    end;
  end;
if (FKnob = ksArrowUp) or (FKnob = ksArrowRight) then
 begin
  if FLook = klNormal then
   begin
   canvas.Rectangle(Rect(Knopf2.Left,Knopf2.Top,Knopf2.Right,Knopf2.Bottom));
   Pfeil[0].Y := Knopf2.Top;
   Pfeil[0].X := Knopf2.Left;
   Pfeil[1].X := MKnob2;
   Pfeil[1].Y := Knopf2.Top-(round(Knopf2.Width/4));
   Pfeil[2].X := Knopf2.Right-1;
   Pfeil[2].Y := Knopf2.Top;
   canvas.Polygon(Pfeil);
   end;

   if FLook = klRipped then
   begin
   Pfeil1[0].Y := Knopf2.Top;
   Pfeil1[0].X := Knopf2.Left;
   Pfeil1[1].X := MKnob2;
   Pfeil1[1].Y := Knopf2.Top-(round(Knopf2.Width/4));
   Pfeil1[2].X := Knopf2.Right;
   Pfeil1[2].Y := Knopf2.Top;
   Pfeil1[3].X := Knopf2.Right;
   Pfeil1[3].Y := Knopf2.Bottom;
   Pfeil1[4].X := Knopf2.Left;
   Pfeil1[4].Y := Knopf2.Bottom;

   canvas.Polygon(Pfeil1);
   canvas.Line(Knopf2.Left+round(5*FakY),Knopf2.Top+round(1.2*FakY),Knopf2.Left+round(5*FakY),Knopf2.Bottom-round(5*FakY));
   canvas.Line(Knopf2.Right-round(5*FakY),Knopf2.Top+round(1.2*FakY),Knopf2.Right-round(5*FakY),Knopf2.Bottom-round(5*FakY));
   end;
 end;
if (FKnob = ksArrowDown) or (FKnob = ksArrowLeft) then
 begin
  if FLook = klNormal then
   begin
   canvas.Rectangle(Rect(Knopf2.Left,Knopf2.Top,Knopf2.Right,Knopf2.Bottom));
   Pfeil[0].Y := Knopf2.Bottom;
   Pfeil[0].X := Knopf2.Left;
   Pfeil[1].X := MKnob2;
   Pfeil[1].Y := Knopf2.Bottom+(round(Knopf2.Width/4));
   Pfeil[2].X := Knopf2.Right-1;
   Pfeil[2].Y := Knopf2.Bottom;
   canvas.Polygon(Pfeil);
   end;
   if FLook = klRipped then
   begin
   Pfeil1[0].Y := Knopf2.Bottom;
   Pfeil1[0].X := Knopf2.Left;
   Pfeil1[1].X := MKnob2;
   Pfeil1[1].Y := Knopf2.Bottom+(round(Knopf2.Width/4));
   Pfeil1[2].X := Knopf2.Right;
   Pfeil1[2].Y := Knopf2.Bottom;
   Pfeil1[3].X := Knopf2.Right;
   Pfeil1[3].Y := Knopf2.Top;
   Pfeil1[4].X := Knopf2.Left;
   Pfeil1[4].Y := Knopf2.Top;

   canvas.Polygon(Pfeil1);
   canvas.Line(Knopf2.Left+round(5*FakY),Knopf2.Top+round(5*FakY),Knopf2.Left+round(5*FakY),Knopf2.Bottom-round(1.2*FakY));
   canvas.Line(Knopf2.Right-round(5*FakY),Knopf2.Top+round(5*FakY),Knopf2.Right-round(5*FakY),Knopf2.Bottom-round(1.2*FakY));
   end;
 end;
end;
//Schiebeknopf
 if FLook = klNormal then canvas.Pen.Color  := FKnobColor
 else canvas.Pen.Color  := FLookColor;

 canvas.Brush.Color:= FKnobColor;
 if FKnob = ksrectangle then
  begin
   if FLook = klNormal then canvas.Rectangle(Knopf);
   if FLook = klRipped then
    begin
     canvas.Rectangle(Knopf);
     canvas.Rectangle(Knopf.Left+round(3*FakY),Knopf.Top+round(3*FakY),Knopf.Right-round(3*FakY),Knopf.Bottom-round(3*FakY));
     canvas.line(Knopf.Left+round(5*FakY),Knopf.Top+round(5*FakY),Knopf.Left+round(5*FakY),Knopf.Bottom-round(5*FakY));
     canvas.line(Knopf.Right-round(5*FakY),Knopf.Top+round(5*FakY),Knopf.Right-round(5*FakY),Knopf.Bottom-round(5*FakY));
    end;
  end;
 if FKnob = kscircle    then
  begin
   if FLook = klNormal then canvas.Ellipse(Knopf);
   if FLook = klRipped then
    begin
     canvas.Ellipse(Knopf);
     canvas.Ellipse(Knopf.Left+round(3*FakY),Knopf.Top+round(3*FakY),Knopf.Right-round(3*FakY),Knopf.Bottom-round(3*FakY));
    end;
  end;
 if FKnob = ksroundrect then
  begin
   if FLook = klNormal then canvas.RoundRect(Knopf,round(4*FakY),round(4*FakY));
   if FLook = klRipped then
    begin
     canvas.RoundRect(Knopf,round(4*FakY),round(4*FakY));
     canvas.RoundRect(rect(Knopf.Left+round(3*FakY),Knopf.Top+round(3*FakY),Knopf.Right-round(3*FakY),Knopf.Bottom-round(3*FakY)),round(4*FakY),round(4*FakY));
     canvas.line(Knopf.Left+round(5*FakY),Knopf.Top+round(5*FakY),Knopf.Left+round(5*FakY),Knopf.Bottom-round(5*FakY));
     canvas.line(Knopf.Right-round(5*FakY),Knopf.Top+round(5*FakY),Knopf.Right-round(5*FakY),Knopf.Bottom-round(5*FakY));
    end;
  end;
 if (FKnob = ksArrowUp) or (FKnob = ksArrowRight) then
  begin
   if FLook = klNormal then
   begin
    canvas.Rectangle(Rect(Knopf.Left,Knopf.Top,Knopf.Right,Knopf.Bottom));
    Pfeil[0].Y := Knopf.Top;
    Pfeil[0].X := Knopf.Left;
    Pfeil[1].X := MKnob;
    Pfeil[1].Y := Knopf.Top-(round(Knopf.Width/4));
    Pfeil[2].X := Knopf.Right-1;
    Pfeil[2].Y := Knopf.Top;
    canvas.Polygon(Pfeil);
   end;
   if FLook = klRipped then
   begin
   Pfeil1[0].Y := Knopf.Top;
   Pfeil1[0].X := Knopf.Left;
   Pfeil1[1].X := MKnob;
   Pfeil1[1].Y := Knopf.Top-(round(Knopf.Width/4));
   Pfeil1[2].X := Knopf.Right;
   Pfeil1[2].Y := Knopf.Top;
   Pfeil1[3].X := Knopf.Right;
   Pfeil1[3].Y := Knopf.Bottom;
   Pfeil1[4].X := Knopf.Left;
   Pfeil1[4].Y := Knopf.Bottom;

   canvas.Polygon(Pfeil1);
   canvas.Line(Knopf.Left+round(5*FakY),Knopf.Top+round(1.2*FakY),Knopf.Left+round(5*FakY),Knopf.Bottom-round(5*FakY));
   canvas.Line(Knopf.Right-round(5*FakY),Knopf.Top+round(1.2*FakY),Knopf.Right-round(5*FakY),Knopf.Bottom-round(5*FakY));
   end;
  end;
 if (FKnob = ksArrowDown) or (FKnob = ksArrowLeft) then
  begin
   if FLook = klNormal then
   begin
    canvas.Rectangle(Rect(Knopf.Left,Knopf.Top,Knopf.Right,Knopf.Bottom));
    Pfeil[0].Y := Knopf.Bottom;
    Pfeil[0].X := Knopf.Left;
    Pfeil[1].X := MKnob;
    Pfeil[1].Y := Knopf.Bottom+(round(Knopf.Width/4));
    Pfeil[2].X := Knopf.Right-1;
    Pfeil[2].Y := Knopf.Bottom;
    canvas.Polygon(Pfeil);
   end;
   if FLook = klRipped then
   begin
   Pfeil1[0].Y := Knopf.Bottom;
   Pfeil1[0].X := Knopf.Left;
   Pfeil1[1].X := MKnob;
   Pfeil1[1].Y := Knopf.Bottom+(round(Knopf.Width/4));
   Pfeil1[2].X := Knopf.Right;
   Pfeil1[2].Y := Knopf.Bottom;
   Pfeil1[3].X := Knopf.Right;
   Pfeil1[3].Y := Knopf.Top;
   Pfeil1[4].X := Knopf.Left;
   Pfeil1[4].Y := Knopf.Top;

   canvas.Polygon(Pfeil1);
   canvas.Line(Knopf.Left+round(5*FakY),Knopf.Top+round(5*FakY),Knopf.Left+round(5*FakY),Knopf.Bottom-round(1.2*FakY));
   canvas.Line(Knopf.Right-round(5*FakY),Knopf.Top+round(5*FakY),Knopf.Right-round(5*FakY),Knopf.Bottom-round(1.2*FakY));
   end;
 end;

 //Wertanzeige
 if FIndicator.FIndicatorVisible then
  begin
   canvas.Brush.Color   := FIndicator.FIndicatorColor;
   canvas.Pen.Color     := FIndicator.FIndicatorColor;
   canvas.Font.Height   := round(10*FakY);
   if canvas.Font.Height < 10 then canvas.Font.Height:= 10;
   canvas.Font.Color    := FIndicator.FIndicatorFontColor;

   if fPosition <= round(fmax/2) then
    begin
     if not Reversed then
      if (FKnob = ksArrowDown) or (FKnob = ksArrowUp) or (FKnob = ksArrowLeft) or (FKnob = ksArrowRight)
      then  canvas.TextOut(Knopf.Right+1,round(MitteY)-round(canvas.TextHeight(inttostr(fPosition))/2),inttostr(fPosition))
      else canvas.TextOut(Knopf.Right,round(MitteY)-round(canvas.TextHeight(inttostr(fPosition))/2),inttostr(fPosition))
     else
      canvas.TextOut(Knopf.Left-canvas.TextWidth(inttostr(fPosition)),round(MitteY)-round(canvas.TextHeight(inttostr(fPosition))/2),inttostr(fPosition));
     end;
   if fPosition > round(fmax/2) then
    begin
     if not Reversed then
      canvas.TextOut(Knopf.Left-canvas.TextWidth(inttostr(fPosition)),round(MitteY)-round(canvas.TextHeight(inttostr(fPosition))/2),inttostr(fPosition))
     else
      if (FKnob = ksArrowDown) or (FKnob = ksArrowUp) or (FKnob = ksArrowLeft) or (FKnob = ksArrowRight)
      then canvas.TextOut(Knopf.Right+1,round(MitteY)-round(canvas.TextHeight(inttostr(fPosition))/2),inttostr(fPosition))
      else canvas.TextOut(Knopf.Right,round(MitteY)-round(canvas.TextHeight(inttostr(fPosition))/2),inttostr(fPosition));
     end;
  end;
 if FTrack.FSlotColorSelVisible then    //bei Kugel als Knopf bei max letzte Pixel abdecken
  begin
   if (FPosition = fmax) and (geaendert=false) and (FMax>0) then
     begin
     tmpcolor:=FTrack.fslotcolor;
     FTrack.FSlotColor:=FTrack.FSlotColorSel;
     geaendert :=true;
     end;
   if (FPosition<> fmax) and geaendert then
    begin
     FTrack.FSlotColor:= tmpcolor;
    end;
  end;
 end;
//xxxxxxxxxxxxxxxxxxxxxxxxx---VERTIKAL---xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
if FOrientation = scVertical then
begin
 FakY   := width / 30;
 MitteY := width / 2;

 links  := round((FakY*8)+(6*FakY));          //linkes Ende der Skala
 rechts := height-round(((FakY*8)+(6*FakY)));  //rechtes Ende der Skala
 Skala  := rechts-links;                      //Länge Skala
 {Positiverbereich 0 bis ..}
 if FMin >=0 then
  begin
   Schritte:= (FMax-FMin);
  end;
 {Negativerbereich }
 if FMax <=0 then
  begin
   Schritte:= (FMax-FMin);
  end;
 {Um 0 }
 if (FMin <0)  and (FMax>0) then
  begin
   Schritte:= (0-FMin)+FMax;
  end;
 Pixelschritt:= Skala/Schritte;
 versatz:=0+FMin;
//Mitte des Knopfes bestimmen
if not Reversed then
 begin
  for lv:= FMin to FMax do
   if lv= FPosition then MKnob:= links+round(Pixelschritt*(lv-versatz));
  for lv:= FMin to FMax do
   if lv= FMultiKnob.FPosKnob2 then MKnob2:= links+round(Pixelschritt*(lv-versatz));
  for lv:= FMin to FMax do
   if lv= FMultiKnob.FPosKnob3 then MKnob3:= links+round(Pixelschritt*(lv-versatz));
 end;
if Reversed then
 begin
  for lv:= FMin to FMax do
   if lv= FPosition then MKnob:= rechts-round(Pixelschritt*(lv-versatz));
  for lv:= FMin to FMax do
   if lv= FMultiKnob.FPosKnob2 then MKnob2:= rechts-round(Pixelschritt*(lv-versatz));
  for lv:= FMin to FMax do
   if lv= FMultiKnob.FPosKnob3 then MKnob3:= rechts-round(Pixelschritt*(lv-versatz));
 end;
 Knopf := rect(round(MitteY-(6*FakY)),round(MKnob-(6*FakY)),round(MitteY+(6*FakY)),round(MKnob+(6*FakY)));
 Knopf := rect(Knopf.Left-1,Knopf.Top-1,Knopf.Right+1,Knopf.Bottom+1);

 Knopf2 := rect(round(MitteY-(6*FakY)),round(MKnob2-(6*FakY)),round(MitteY+(6*FakY)),round(MKnob2+(6*FakY)));
 Knopf2:= rect(Knopf2.Left-1,Knopf2.Top-1,Knopf2.Right+1,Knopf2.Bottom+1);

 Knopf3 := rect(round(MitteY-(6*FakY)),round(MKnob3-(6*FakY)),round(MitteY+(6*FakY)),round(MKnob3+(6*FakY)));
 Knopf3:= rect(Knopf3.Left-1,Knopf3.Top-1,Knopf3.Right+1,Knopf3.Bottom+1);


//Hintergrund
 temp              := canvas.Pen.Width;
 canvas.Pen.Width  := FBorderWidth;
 canvas.Pen.Color  := FBorderColor;
 canvas.Brush.Color:=FBackgroundColor;
 canvas.Rectangle(0,0,width,height);
 canvas.Pen.Width  := temp;
//Schiebenut
 canvas.Pen.Color  := FTrack.FSlotColor;
 canvas.Brush.Color:= FTrack.FSlotColor;
 x1:= round(FakY*8);
 y1:= round(MitteY-(3*FakY));
 x2:= height-round(FakY*8);
 y2:= round(MitteY+(3*FakY));
 canvas.Rectangle(y1,x1,y2,x2);

 if FTrack.FSlotColorExtVisible then           //Extrafarbe
  begin
   canvas.Pen.Color  := FTrack.FSlotColorExt;
   canvas.Brush.Color:= FTrack.FSlotColorExt;

   for lv:= FMin to FMax do
    begin
     if not Reversed then
      begin
       if lv= FTrack.FExtMin then ExtL:= links+round(Pixelschritt*(lv-versatz));
       if lv= FTrack.FExtMax then ExtR:= links+round(Pixelschritt*(lv-versatz));
      end else
      begin
       if lv= FTrack.FExtMin then ExtL:= rechts-round(Pixelschritt*(lv-versatz));
       if lv= FTrack.FExtMax then ExtR:= rechts-round(Pixelschritt*(lv-versatz));
      end;
    end;
   canvas.Rectangle(round(MitteY-(3*FakY)),ExtL,round(MitteY+(3*FakY)),ExtR);
   if not Reversed then
      begin
       if FTrack.FExtMin = fmin then canvas.Rectangle(round(MitteY-(3*FakY)),round(FakY*8),round(MitteY+(3*FakY)),ExtR);
       if FTrack.FExtMax = fmax then canvas.Rectangle(round(MitteY-(3*FakY)),ExtL,round(MitteY+(3*FakY)),height-round(FakY*8));
      end else
      begin
       if FTrack.FExtMax = fmax then canvas.Rectangle(round(MitteY-(3*FakY)),round(FakY*8),round(MitteY+(3*FakY)),ExtL);
       if FTrack.FExtMin = fmin then canvas.Rectangle(round(MitteY-(3*FakY)),ExtR,round(MitteY+(3*FakY)),height-round(FakY*8));
      end;
  end;

 if FTrack.FSlotColorSelVisible then        //SelectedColor
  begin
   canvas.Pen.Color  := FTrack.FSlotColorSel;
   canvas.Brush.Color:= FTrack.FSlotColorSel;
   if not Reversed then
    begin
     if (FMax<=0) then canvas.Rectangle(round(MitteY-(3*FakY)),MKnob,round(MitteY+(3*FakY)),height-round(FakY*8))
     else canvas.Rectangle(round(MitteY-(3*FakY)),round(FakY*8),round(MitteY+(3*FakY)),MKnob);
    end else
    begin
     if (FMax<=0) then canvas.Rectangle(round(MitteY-(3*FakY)),round(FakY*8),round(MitteY+(3*FakY)),MKnob)
     else canvas.Rectangle(round(MitteY-(3*FakY)),MKnob,round(MitteY+(3*FakY)),height-round(FakY*8));
    end;
   canvas.Pen.Color  := FTrack.FSlotColor;
   canvas.Brush.Color:= FTrack.FSlotColor;
  end;

 if FScale.FShowScale then      //Skala
  begin
   canvas.Pen.Color   :=FScale.FLineColor;
   if not FScale.OtherSide then
    canvas.Line(Knopf.Left-round(3*FakY),links,Knopf.Left-round(3*FakY),rechts)
   else
    canvas.Line(Knopf.Right+round(3*FakY),links,Knopf.Right+round(3*FakY),rechts);


   canvas.Pen.Color   :=FScale.FMarkColor;     //kleine Markierungen
   canvas.Brush.Color :=FScale.FMarkColor;
   if not FScale.OtherSide then
    begin
     ScMark             := rect(((Knopf.Left-round(3*FakY))+round(2*FakY)),links-round(2*FakY),(Knopf.Left-round(3*FakY))-round(2*FakY),links+round(2*FakY));
     for lv:= 0 to round((FMax-FMin)/FScale.FInterval)-1 do
     Canvas.Ellipse(SCMark.Left,SCMark.Top+round(Pixelschritt*lv*FScale.FInterval),SCMark.Right,SCMark.Bottom+round(Pixelschritt*lv*FScale.FInterval));
     Canvas.Ellipse(SCMark.Left,(SCMark.Top+rechts)-links,SCMark.Right,(SCMark.Bottom+rechts)-links);
    end else
    begin
     ScMark := rect(((Knopf.Right+round(3*FakY))+round(2*FakY)),links-round(2*FakY),(Knopf.Right+round(3*FakY))-round(2*FakY),links+round(2*FakY));
     for lv:= 0 to round((FMax-FMin)/FScale.FInterval)-1 do
     Canvas.Ellipse(SCMark.Left,SCMark.Top+round(Pixelschritt*lv*FScale.FInterval),SCMark.Right,SCMark.Bottom+round(Pixelschritt*lv*FScale.FInterval));
     Canvas.Ellipse(SCMark.Left,(SCMark.Top+rechts)-links,SCMark.Right,(SCMark.Bottom+rechts)-links);
    end;
 if FScale.FShowBigMark then
  begin
   bigfak:= 2*FScale.FBigMarkSize;
   canvas.Pen.Color   :=FScale.FBigMarkColor;     //Big Marks
   canvas.Brush.Color :=FScale.FBigMarkColor;
   if not FScale.OtherSide then
    begin
     ScMark := rect(((Knopf.Left-round(3*FakY))+round(bigfak*FakY)),links-round(bigfak*FakY),(Knopf.Left-round(3*FakY))-round(bigfak*FakY),links+round(bigfak*FakY));
     for lv:= 0 to round((FMax-FMin)/FScale.FBigMarkInterval)-1 do
     Canvas.Ellipse(SCMark.Left,SCMark.Top+round(Pixelschritt*lv*FScale.FBigMarkInterval),SCMark.Right,SCMark.Bottom+round(Pixelschritt*lv*FScale.FBigMarkInterval));
     Canvas.Ellipse(SCMark.Left,(SCMark.Top+rechts)-links,SCMark.Right,(SCMark.Bottom+rechts)-links);
    end else
    begin
     ScMark := rect(((Knopf.Right+round(3*FakY))+round(bigfak*FakY)),links-round(bigfak*FakY),(Knopf.Right+round(3*FakY))-round(bigfak*FakY),links+round(bigfak*FakY));
     for lv:= 0 to round((FMax-FMin)/FScale.FBigMarkInterval)-1 do
     Canvas.Ellipse(SCMark.Left,SCMark.Top+round(Pixelschritt*lv*FScale.FBigMarkInterval),SCMark.Right,SCMark.Bottom+round(Pixelschritt*lv*FScale.FBigMarkInterval));
     Canvas.Ellipse(SCMark.Left,(SCMark.Top+rechts)-links,SCMark.Right,(SCMark.Bottom+rechts)-links);
    end;
   end;
 end;

 //Position der Markierung
 for lv:= FMin to FMax do
   begin
    if lv= FMark.FMarkPosition then
     begin
      if not Reversed then
       begin
        Mark1[0]:=Point(Knopf.Left,links+round(Pixelschritt*(lv-versatz)));
        Mark1[1]:=Point(Knopf.Left-round(5*FakY),Mark1[0].y+round(5*FakY));
        Mark1[2]:=Point(Knopf.Left-round(5*FakY),Mark1[0].Y-round(5*FakY));
       end else
       begin
        Mark1[0]:=Point(Knopf.Left,rechts-round(Pixelschritt*(lv-versatz)));
        Mark1[1]:=Point(Knopf.Left-round(5*FakY),Mark1[0].y+round(5*FakY));
        Mark1[2]:=Point(Knopf.Left-round(5*FakY),Mark1[0].Y-round(5*FakY));
       end;
     end;
   end;
 for lv:= FMin to FMax do         //Position der 2.Markierung
   begin
    if lv= FMark.FMark2Position then
     begin
      if not Reversed then
       begin
        Mark2[0]:=Point(Knopf.Left,links+round(Pixelschritt*(lv-versatz)));
        Mark2[1]:=Point(Knopf.Left-round(5*FakY),Mark2[0].y+round(5*FakY));
        Mark2[2]:=Point(Knopf.Left-round(5*FakY),Mark2[0].Y-round(5*FakY));
       end else
       begin
        Mark2[0]:=Point(Knopf.Left,rechts-round(Pixelschritt*(lv-versatz)));
        Mark2[1]:=Point(Knopf.Left-round(5*FakY),Mark2[0].y+round(5*FakY));
        Mark2[2]:=Point(Knopf.Left-round(5*FakY),Mark2[0].Y-round(5*FakY));
       end;
     end;
   end;
 if FMark.FMarkVisible then    //Markierung
  begin
   canvas.Pen.Color  := FMark.FMarkColor;
   canvas.Brush.Color:= FMark.FMarkColor;
   canvas.Line(round(MitteY),MKnob,Knopf.Left,MKnob); //Markierung im SchiebeKnopf
   canvas.Polygon(Mark1);
  end;
 if FMark.FMark2Visible then    //2.Markierung
  begin
   canvas.Pen.Color  := FMark.FMarkColor;
   canvas.Brush.Color:= FMark.FMarkColor;
   canvas.Polygon(Mark2);
  end;


//SchiebeKnopf3
if FMultiKnob.FShowKnob3 then
 begin
  if FLook = klNormal then canvas.Pen.Color  := FMultiKnob.ColorKnob3
  else canvas.Pen.Color  := FLookColor;
  canvas.Brush.Color:= FMultiKnob.ColorKnob3;

  if FKnob = ksrectangle then
  begin
   if FLook = klNormal then canvas.Rectangle(Knopf3);
   if FLook = klRipped then
    begin
     canvas.Rectangle(Knopf3);
     canvas.Rectangle(Knopf3.Left+round(3*FakY),Knopf3.Top+round(3*FakY),Knopf3.Right-round(3*FakY),Knopf3.Bottom-round(3*FakY));
     canvas.line(Knopf3.Left+round(5*FakY),Knopf3.Top+round(5*FakY),Knopf3.Right-round(5*FakY),Knopf3.Top+round(5*FakY));
     canvas.line(Knopf3.Left+round(5*FakY),Knopf3.Bottom-round(5*FakY),Knopf3.Right-round(5*FakY),Knopf3.Bottom-round(5*FakY));
    end;
  end;
 if FKnob = kscircle    then
  begin
   if FLook = klNormal then canvas.Ellipse(Knopf3);
   if FLook = klRipped then
    begin
     canvas.Ellipse(Knopf3);
     canvas.Ellipse(Knopf3.Left+round(3*FakY),Knopf3.Top+round(3*FakY),Knopf3.Right-round(3*FakY),Knopf3.Bottom-round(3*FakY));
    end;
  end;
 if FKnob = ksroundrect then
  begin
   if FLook = klNormal then canvas.RoundRect(Knopf3,round(4*FakY),round(4*FakY));
   if FLook = klRipped then
    begin
     canvas.RoundRect(Knopf3,round(4*FakY),round(4*FakY));
     canvas.RoundRect(rect(Knopf3.Left+round(3*FakY),Knopf3.Top+round(3*FakY),Knopf3.Right-round(3*FakY),Knopf3.Bottom-round(3*FakY)),round(4*FakY),round(4*FakY));
     canvas.line(Knopf3.Left+round(5*FakY),Knopf3.Top+round(5*FakY),Knopf3.Right-round(5*FakY),Knopf3.Top+round(5*FakY));
     canvas.line(Knopf3.Left+round(5*FakY),Knopf3.Bottom-round(5*FakY),Knopf3.Right-round(5*FakY),Knopf3.Bottom-round(5*FakY));
    end;
  end;
 if (FKnob = ksArrowDown) or (FKnob = ksArrowLeft) then  //Left
  begin
    if FLook = klNormal then
     begin
      canvas.Rectangle(Rect(Knopf3.Left,Knopf3.Top,Knopf3.Right,Knopf3.Bottom));
      Pfeil[0].Y := Knopf3.Top;
      Pfeil[0].X := Knopf3.Left;
      Pfeil[1].Y := MKnob3;
      Pfeil[1].X := Knopf3.Left-(round(Knopf3.Width/4));
      Pfeil[2].X := Knopf3.Left;
      Pfeil[2].Y := Knopf3.Bottom-1;
      canvas.Polygon(Pfeil);
     end;
    if FLook = klRipped then
     begin
      Pfeil1[0].Y := Knopf3.Top;
      Pfeil1[0].X := Knopf3.Left;
      Pfeil1[1].Y := MKnob3;
      Pfeil1[1].X := Knopf3.Left-(round(Knopf3.Width/4));
      Pfeil1[2].X := Knopf3.Left;
      Pfeil1[2].Y := Knopf3.Bottom;
      Pfeil1[3].X := Knopf3.Right;
      Pfeil1[3].Y := Knopf3.Bottom;
      Pfeil1[4].X := Knopf3.Right;
      Pfeil1[4].Y := Knopf3.Top;

      canvas.Polygon(Pfeil1);
      canvas.Line(Knopf3.Left+round(1.2*FakY),Knopf3.Top+round(5*FakY),Knopf3.Right-round(3*FakY),Knopf3.Top+round(5*FakY));
      canvas.Line(Knopf3.Left+round(1.2*FakY),Knopf3.Bottom-round(5*FakY),Knopf3.Right-round(3*FakY),Knopf3.Bottom-round(5*FakY));
     end;
   end;


 if (FKnob = ksArrowUp) or (FKnob = ksArrowRight) then
   begin
    if FLook = klNormal then
     begin
      canvas.Rectangle(Rect(Knopf3.Left,Knopf3.Top,Knopf3.Right,Knopf3.Bottom));
      Pfeil[0].Y := Knopf3.Top;
      Pfeil[0].X := Knopf3.Right;
      Pfeil[1].Y := MKnob3;
      Pfeil[1].X := Knopf3.Right+(round(Knopf3.Width/4));
      Pfeil[2].X := Knopf3.Right;
      Pfeil[2].Y := Knopf3.Bottom-1;
      canvas.Polygon(Pfeil);
     end;
    if FLook = klRipped then
     begin
      Pfeil1[0].Y := Knopf3.Top;
      Pfeil1[0].X := Knopf3.Right;
      Pfeil1[1].Y := MKnob3;
      Pfeil1[1].X := Knopf3.Right+(round(Knopf3.Width/4));
      Pfeil1[2].X := Knopf3.Right;
      Pfeil1[2].Y := Knopf3.Bottom;
      Pfeil1[3].X := Knopf3.Left;
      Pfeil1[3].Y := Knopf3.Bottom;
      Pfeil1[4].X := Knopf3.Left;
      Pfeil1[4].Y := Knopf3.Top;

      canvas.Polygon(Pfeil1);
      canvas.Line(Knopf3.Left+round(3*FakY),Knopf3.Top+round(5*FakY),Knopf3.Right-round(1.2*FakY),Knopf3.Top+round(5*FakY));
      canvas.Line(Knopf3.Left+round(3*FakY),Knopf3.Bottom-round(5*FakY),Knopf3.Right-round(1.2*FakY),Knopf3.Bottom-round(5*FakY));
     end;
  end;
end;
//SchiebeKnopf2
if FMultiKnob.FShowKnob2 then
begin
 if FLook = klNormal then canvas.Pen.Color  := FMultiKnob.ColorKnob2
 else canvas.Pen.Color  := FLookColor;
 canvas.Brush.Color:= FMultiKnob.ColorKnob2;

 if FKnob = ksrectangle then
  begin
   if FLook = klNormal then canvas.Rectangle(Knopf2);
   if FLook = klRipped then
    begin
     canvas.Rectangle(Knopf2);
     canvas.Rectangle(Knopf2.Left+round(3*FakY),Knopf2.Top+round(3*FakY),Knopf2.Right-round(3*FakY),Knopf2.Bottom-round(3*FakY));
     canvas.line(Knopf2.Left+round(5*FakY),Knopf2.Top+round(5*FakY),Knopf2.Right-round(5*FakY),Knopf2.Top+round(5*FakY));
     canvas.line(Knopf2.Left+round(5*FakY),Knopf2.Bottom-round(5*FakY),Knopf2.Right-round(5*FakY),Knopf2.Bottom-round(5*FakY));
    end;
  end;
 if FKnob = kscircle    then
  begin
   if FLook = klNormal then canvas.Ellipse(Knopf2);
   if FLook = klRipped then
    begin
     canvas.Ellipse(Knopf2);
     canvas.Ellipse(Knopf2.Left+round(3*FakY),Knopf2.Top+round(3*FakY),Knopf2.Right-round(3*FakY),Knopf2.Bottom-round(3*FakY));
    end;
  end;
 if FKnob = ksroundrect then
  begin
   if FLook = klNormal then canvas.RoundRect(Knopf2,round(4*FakY),round(4*FakY));
   if FLook = klRipped then
    begin
     canvas.RoundRect(Knopf2,round(4*FakY),round(4*FakY));
     canvas.RoundRect(rect(Knopf2.Left+round(3*FakY),Knopf2.Top+round(3*FakY),Knopf2.Right-round(3*FakY),Knopf2.Bottom-round(3*FakY)),round(4*FakY),round(4*FakY));
     canvas.line(Knopf2.Left+round(5*FakY),Knopf2.Top+round(5*FakY),Knopf2.Right-round(5*FakY),Knopf2.Top+round(5*FakY));
     canvas.line(Knopf2.Left+round(5*FakY),Knopf2.Bottom-round(5*FakY),Knopf2.Right-round(5*FakY),Knopf2.Bottom-round(5*FakY));
    end;
  end;
 if (FKnob = ksArrowDown) or (FKnob = ksArrowLeft) then  //Left
  begin
    if FLook = klNormal then
     begin
      canvas.Rectangle(Rect(Knopf2.Left,Knopf2.Top,Knopf2.Right,Knopf2.Bottom));
      Pfeil[0].Y := Knopf2.Top;
      Pfeil[0].X := Knopf2.Left;
      Pfeil[1].Y := MKnob2;
      Pfeil[1].X := Knopf2.Left-(round(Knopf2.Width/4));
      Pfeil[2].X := Knopf2.Left;
      Pfeil[2].Y := Knopf2.Bottom-1;
      canvas.Polygon(Pfeil);
     end;
    if FLook = klRipped then
     begin
      Pfeil1[0].Y := Knopf2.Top;
      Pfeil1[0].X := Knopf2.Left;
      Pfeil1[1].Y := MKnob2;
      Pfeil1[1].X := Knopf2.Left-(round(Knopf2.Width/4));
      Pfeil1[2].X := Knopf2.Left;
      Pfeil1[2].Y := Knopf2.Bottom;
      Pfeil1[3].X := Knopf2.Right;
      Pfeil1[3].Y := Knopf2.Bottom;
      Pfeil1[4].X := Knopf2.Right;
      Pfeil1[4].Y := Knopf2.Top;

      canvas.Polygon(Pfeil1);
      canvas.Line(Knopf2.Left+round(1.2*FakY),Knopf2.Top+round(5*FakY),Knopf2.Right-round(3*FakY),Knopf2.Top+round(5*FakY));
      canvas.Line(Knopf2.Left+round(1.2*FakY),Knopf2.Bottom-round(5*FakY),Knopf2.Right-round(3*FakY),Knopf2.Bottom-round(5*FakY));
     end;
   end;


 if (FKnob = ksArrowUp) or (FKnob = ksArrowRight) then
  begin
   if FLook = klNormal then
     begin
      canvas.Rectangle(Rect(Knopf2.Left,Knopf2.Top,Knopf2.Right,Knopf2.Bottom));
      Pfeil[0].Y := Knopf2.Top;
      Pfeil[0].X := Knopf2.Right;
      Pfeil[1].Y := MKnob2;
      Pfeil[1].X := Knopf2.Right+(round(Knopf2.Width/4));
      Pfeil[2].X := Knopf2.Right;
      Pfeil[2].Y := Knopf2.Bottom-1;
      canvas.Polygon(Pfeil);
     end;
    if FLook = klRipped then
     begin
      Pfeil1[0].Y := Knopf2.Top;
      Pfeil1[0].X := Knopf2.Right;
      Pfeil1[1].Y := MKnob2;
      Pfeil1[1].X := Knopf2.Right+(round(Knopf2.Width/4));
      Pfeil1[2].X := Knopf2.Right;
      Pfeil1[2].Y := Knopf2.Bottom;
      Pfeil1[3].X := Knopf2.Left;
      Pfeil1[3].Y := Knopf2.Bottom;
      Pfeil1[4].X := Knopf2.Left;
      Pfeil1[4].Y := Knopf2.Top;

      canvas.Polygon(Pfeil1);
      canvas.Line(Knopf2.Left+round(3*FakY),Knopf2.Top+round(5*FakY),Knopf2.Right-round(1.2*FakY),Knopf2.Top+round(5*FakY));
      canvas.Line(Knopf2.Left+round(3*FakY),Knopf2.Bottom-round(5*FakY),Knopf2.Right-round(1.2*FakY),Knopf2.Bottom-round(5*FakY));
     end;
   end;
end;
//Schiebeknopf
 if FLook = klNormal then canvas.Pen.Color  := FKnobColor
 else canvas.Pen.Color  := FLookColor;
 canvas.Brush.Color:= FKnobColor;

 if FKnob = ksrectangle then
  begin
   if FLook = klNormal then canvas.Rectangle(Knopf);
   if FLook = klRipped then
    begin
     canvas.Rectangle(Knopf);
     canvas.Rectangle(Knopf.Left+round(3*FakY),Knopf.Top+round(3*FakY),Knopf.Right-round(3*FakY),Knopf.Bottom-round(3*FakY));
     canvas.line(Knopf.Left+round(5*FakY),Knopf.Top+round(5*FakY),Knopf.Right-round(5*FakY),Knopf.Top+round(5*FakY));
     canvas.line(Knopf.Left+round(5*FakY),Knopf.Bottom-round(5*FakY),Knopf.Right-round(5*FakY),Knopf.Bottom-round(5*FakY));
    end;
  end;
 if FKnob = kscircle    then
  begin
   if FLook = klNormal then canvas.Ellipse(Knopf);
   if FLook = klRipped then
    begin
     canvas.Ellipse(Knopf);
     canvas.Ellipse(Knopf.Left+round(3*FakY),Knopf.Top+round(3*FakY),Knopf.Right-round(3*FakY),Knopf.Bottom-round(3*FakY));
    end;
  end;
 if FKnob = ksroundrect then
  begin
   if FLook = klNormal then canvas.RoundRect(Knopf,round(4*FakY),round(4*FakY));
   if FLook = klRipped then
    begin
     canvas.RoundRect(Knopf,round(4*FakY),round(4*FakY));
     canvas.RoundRect(rect(Knopf.Left+round(3*FakY),Knopf.Top+round(3*FakY),Knopf.Right-round(3*FakY),Knopf.Bottom-round(3*FakY)),round(4*FakY),round(4*FakY));
     canvas.line(Knopf.Left+round(5*FakY),Knopf.Top+round(5*FakY),Knopf.Right-round(5*FakY),Knopf.Top+round(5*FakY));
     canvas.line(Knopf.Left+round(5*FakY),Knopf.Bottom-round(5*FakY),Knopf.Right-round(5*FakY),Knopf.Bottom-round(5*FakY));
    end;
  end;
 if (FKnob = ksArrowDown) or (FKnob = ksArrowLeft) then  //Left
  begin
    if FLook = klNormal then
     begin
      canvas.Rectangle(Rect(Knopf.Left,Knopf.Top,Knopf.Right,Knopf.Bottom));
      Pfeil[0].Y := Knopf.Top;
      Pfeil[0].X := Knopf.Left;
      Pfeil[1].Y := MKnob;
      Pfeil[1].X := Knopf.Left-(round(Knopf.Width/4));
      Pfeil[2].X := Knopf.Left;
      Pfeil[2].Y := Knopf.Bottom-1;
      canvas.Polygon(Pfeil);
     end;
    if FLook = klRipped then
     begin
      Pfeil1[0].Y := Knopf.Top;
      Pfeil1[0].X := Knopf.Left;
      Pfeil1[1].Y := MKnob;
      Pfeil1[1].X := Knopf.Left-(round(Knopf.Width/4));
      Pfeil1[2].X := Knopf.Left;
      Pfeil1[2].Y := Knopf.Bottom;
      Pfeil1[3].X := Knopf.Right;
      Pfeil1[3].Y := Knopf.Bottom;
      Pfeil1[4].X := Knopf.Right;
      Pfeil1[4].Y := Knopf.Top;

      canvas.Polygon(Pfeil1);
      canvas.Line(Knopf.Left+round(1.2*FakY),Knopf.Top+round(5*FakY),Knopf.Right-round(3*FakY),Knopf.Top+round(5*FakY));
      canvas.Line(Knopf.Left+round(1.2*FakY),Knopf.Bottom-round(5*FakY),Knopf.Right-round(3*FakY),Knopf.Bottom-round(5*FakY));
     end;
   end;

 if (FKnob = ksArrowUp) or (FKnob = ksArrowRight) then //Right
  begin
   if FLook = klNormal then
     begin
      canvas.Rectangle(Rect(Knopf.Left,Knopf.Top,Knopf.Right,Knopf.Bottom));
      Pfeil[0].Y := Knopf.Top;
      Pfeil[0].X := Knopf.Right;
      Pfeil[1].Y := MKnob;
      Pfeil[1].X := Knopf.Right+(round(Knopf.Width/4));
      Pfeil[2].X := Knopf.Right;
      Pfeil[2].Y := Knopf.Bottom-1;
      canvas.Polygon(Pfeil);
     end;
    if FLook = klRipped then
     begin
      Pfeil1[0].Y := Knopf.Top;
      Pfeil1[0].X := Knopf.Right;
      Pfeil1[1].Y := MKnob;
      Pfeil1[1].X := Knopf.Right+(round(Knopf.Width/4));
      Pfeil1[2].X := Knopf.Right;
      Pfeil1[2].Y := Knopf.Bottom;
      Pfeil1[3].X := Knopf.Left;
      Pfeil1[3].Y := Knopf.Bottom;
      Pfeil1[4].X := Knopf.Left;
      Pfeil1[4].Y := Knopf.Top;

      canvas.Polygon(Pfeil1);
      canvas.Line(Knopf.Left+round(3*FakY),Knopf.Top+round(5*FakY),Knopf.Right-round(1.2*FakY),Knopf.Top+round(5*FakY));
      canvas.Line(Knopf.Left+round(3*FakY),Knopf.Bottom-round(5*FakY),Knopf.Right-round(1.2*FakY),Knopf.Bottom-round(5*FakY));
     end;
  end;
 //Wertanzeige
 if FIndicator.FIndicatorVisible then
  begin
   canvas.Brush.Color   := FIndicator.FIndicatorColor;
   canvas.Pen.Color     := FIndicator.FIndicatorColor;
   canvas.Font.Height   := round(10*FakY);
   if canvas.Font.Height < 10 then canvas.Font.Height:= 10;
   canvas.Font.Color    := FIndicator.FIndicatorFontColor;

   if (Fmax<=0) and (Fmin<0) then temp:=fmin else temp:=fmax;
   if fPosition <= round(temp/2) then
    begin
     if not Reversed then
      if (FKnob = ksArrowLeft) or (FKnob = ksArrowRight) or (FKnob = ksArrowDown) or (FKnob = ksArrowUp)
      then canvas.TextOut(round(width/2)-round(canvas.TextWidth(inttostr(fPosition))/2),Knopf.Bottom+1,inttostr(fPosition))
      else canvas.TextOut(round(width/2)-round(canvas.TextWidth(inttostr(fPosition))/2),Knopf.Bottom,inttostr(fPosition))
     else
      canvas.TextOut(round(width/2)-round(canvas.TextWidth(inttostr(fPosition))/2),Knopf.Top-canvas.TextHeight(inttostr(fPosition)),inttostr(fPosition));
     end;
   if fPosition > round(temp/2) then
    begin
     if not Reversed then
      canvas.TextOut(round(width/2)-round(canvas.TextWidth(inttostr(fPosition))/2),Knopf.Top-canvas.TextHeight(inttostr(fPosition)),inttostr(fPosition))
     else
     begin
      if (FKnob = ksArrowLeft) or (FKnob = ksArrowRight) or (FKnob = ksArrowDown) or (FKnob = ksArrowUp)
      then canvas.TextOut(round(width/2)-round(canvas.TextWidth(inttostr(fPosition))/2),Knopf.Bottom+1,inttostr(fPosition))
      else canvas.TextOut(round(width/2)-round(canvas.TextWidth(inttostr(fPosition))/2),Knopf.Bottom,inttostr(fPosition));
     end;
    end;
 end;

 if FTrack.FSlotColorSelVisible then    //bei Kugel als Knopf bei max letzte Pixel abdecken
  begin
   if (FPosition = fmax) and (geaendert=false) and (FMax>0) then
     begin
     tmpcolor:=FTrack.fslotcolor;
     FTrack.FSlotColor:=FTrack.FSlotColorSel;
     geaendert :=true;
     end;
   if (FPosition<> fmax) and geaendert then
    begin
     FTrack.FSlotColor:= tmpcolor;
    end;
  end;

end;
if Focused then     // 13.04.2020 Siro
  begin
   canvas.Pen.Width  := 1;
   canvas.Brush.Style:= bsclear;
   canvas.Pen.Color  := FFocusColor1;
   canvas.Rectangle(0+2,0+2,width-2,height-2);
   canvas.Pen.Color  := FFocusColor2;
   canvas.Pen.Style  := psdot;
   canvas.Rectangle(0+2,0+2,width-2,height-2);
  end;
 canvas.Pen.Width  := FBorderWidth;
 canvas.Pen.Color  := FBorderColor;
 canvas.Pen.Style  := pssolid;
 canvas.Brush.Style:=bssolid;



end;


procedure Register;
begin
  {$I slidercomponent_icon.lrs}
  RegisterComponents('Standard',[TSliderComponent]);
end;

end.
